Description

This is a guide on installing JSbin on FreeBSD.

UPDATE: | found that JSbin works on node v0.10, the default nodejs version for FreeBSD is ¥8-12. Once | installed the older version
JSbin installed correctly.

UPDATE: Fhis-guide-has-beenupdated-forFreeBSB10.

WARNING: JSbin will only run on nodejs 0.10; as of 1 Oct. 2016 the ports tree does not have www/node010; so an older snapshot of
the ports tree must be used. JSbin will not run on FreeBSD 10 otherwise.

Prepare the system

* Make sure the system is up to date and ports tree is installed:

pkg update && pkg upgrade
e Use the version of the ports tree with node010:

svn checkout svn://svn.freebsd.org/ports/branches/2016Q3 /usr/ports/
* Add the following to the make.conf file to use nginx while compiling passenger:

echo 'OPTIONS_UNSET+= DOCS NLS X11 EXAMPLES' >> /etc/make.conf
echo 'OPTIONS_SET+= NODE01l0' >> /etc/make.conf

e |nstall a few dependencies:

pkg install portmaster libzmg2 nasm git sglite3 pkgconf autoconf python gmake
e |nstall node010 and npm2 from the ports tree:

portmaster www/node0l0 www/npm?2
o [nstall grunt-cli globally using npm:

npm install -g grunt grunt-cli

Add a jsbin user to separate privileges:
pw add user -n jsbin -m -s /bin/sh -c "JSbin"

Install JSbin

e |nstall jsbin globally:

npm install --sglite=/usr/local -g jsbin

* Create a new config file and edit it as necessary:

cp /usr/local/lib/node_modules/Jjsbin/config.default.json /usr/local/lib/node_modules/jsbin/con
fig.local. json

o Edit the jsbin config file:

vi /usr/local/lib/node_modules/jsbin/config.local. json

o Modify the env, timezone, and url settings:

"env": "production",
"timezone": "PST",
"url": {
"host": "jsbin.example.com",
"prefix": "/",
"ssl": true,
"static": false,
"runner": false
}I
"session": {
"secret": "v09sfykaZ2e32vdxa%9k297d1l"
}I
"store": {
"adapter": "sqglite",
"sglite": {
"location": "jsbin.sglite"

b
by

e Build the production environment files:

cd /usr/local/lib/node_modules/jsbin
npm install grunt-contrib-uglify grunt-contrib-jshint grunt-contrib-concat
grunt build

e Change the ownership of the jsbin site to the jsbin user:

chown -R jsbin /usr/local/lib/node_modules/jsbin

e Test JShin:

su - Jjsbin
Jsbin

NOTE: Press Ctrl+C to kill the test server when finished.

e Go to http://jsbin.example.com:3000 in a web browser

¢ Exit from the jsbin user:

exit

Running JSbin with PM2

e |nstall pm2 globally:
npm install -g pm2

e Switch to the jsbin user:
su - Jjsbin

e Start jsbin using pm2:

pm2 start /usr/local/lib/node_modules/jsbin/bin/jsbin
exit

JSbin Init Script

® Create a jsbin FreeBSD init script:

vi /usr/local/etc/rc.d/jsbin

o and add the following

#!/bin/sh

# PROVIDE: Jjsbin
# KEYWORD: shutdown

/etc/rc.subr
name="7jsbin"

jsbin_port="3000"
jsbin_proxy="off"

start_cmd="${name}_start"
stop_cmd="${name}_stop"

jsbin_start () {

echo "pm2 starting"

su - Jsbin -c "cd /usr/local/lib/node_modules/Jjsbin; /usr/bin/env PORT=${]jsbin_port} JS
BIN_PROXY=${]jsbin_proxy} /usr/local/bin/pm2 —--name ${name} start /usr/local/lib/node_modul
es/Jjsbin/bin/jsbin; exit"

}

jsbin_stop () {

03/13/2024 3/7



http://jsbin.example.com:3000

echo "pm2 stopping"
su — Jsbin -c "/usr/local/bin/pm2 delete ${name}; exit"

run_rc_command "$1"
* And make it executable:
chmod +x /usr/local/etc/rc.d/jsbin
e Start and enable jsbin at boot

echo 'jsbin_enable="YES"' >> /etc/rc.conf
echo 'jsbin_proxy="on"' >> /etc/rc.conf
service Jjsbin start

Install Nginx

e |nstall Nginx
pkg install nginx
e Start and enable nginx at boot:

echo 'nginx_enable="YES"' >> /etc/rc.conf
service nginx start

e Create a configuration directory to make managing individual server blocks easier
mkdir /usr/local/etc/nginx/conf.d
¢ Edit the main nginx config file:

vi /usr/local/etc/nginx/nginx.conf

o And strip down the config file and add the include statement at the end to make it easier to handle various server blocks:

worker_processes 1;
error_log /var/log/nginx-error.log;

events {
worker_connections 1024;

http {
include mime.types;
default_type application/octet—-stream;
sendfile on;

keepalive_timeout 65;

# Load config files from the /etc/nginx/conf.d directory
include /usr/local/etc/nginx/conf.d/*.conf;
e Add a default site server block:

vi /usr/local/etc/nginx/conf.d/www.example.com.conf

o Add the following:

server {
listen 80;
server_name jsbin.example.com;
root /usr/local/lib/node_modules/jsbin/public;
index index.html;

location @jsbin {
proxy_pass http://localhost:3000;
proxy_set_header Host S$host;
proxy_set_header X-Real-IP S$remote_addr;
proxy_set_header X-Forwarded-For S$proxy_add_x_forwarded_for;
proxy_redirect off;
proxy_set_header X-Accel-Buffering no;

proxy_set_header Connection '';

proxy_http_version 1.1;
proxy_buffering off;
proxy_cache off;

proxy_set_header X-Forwarded-Proto https;

location / {
add_header Pragma "public";
add_header Cache-Control "public, must-revalidate, proxy-revalidate";
add_header Last-Modified $sent_http_Expires;
add_header Access-Control-Allow-Origin *;
try_files S$uri Suri/ Q@jsbin;

e And restart nginx:

service nginx restart

Resources

e https://github.com/jsbin/jsbin
e https://jsbin.com/help/running-a-local-copy-of-jsbin
e https://github.com/jsbin/jsbin/blob/master/docs/running-your-own-jsbin.md

History

#1 - 08/29/2015 12:11 AM - Daniel Curtis

- Description updated

#2 - 08/29/2015 10:26 AM - Daniel Curtis
- Description updated

- Status changed from New to Rejected

#3 - 08/31/2015 03:43 PM - Daniel Curtis

- Description updated
https://github.com/jsbin/jsbin
- Status changed from Rejected to In Progress

- % Done changed from 0 to 50

#4 - 08/31/2015 05:31 PM - Daniel Curtis
- Description updated

- % Done changed from 50 to 80

#5 - 08/31/2015 05:38 PM - Daniel Curtis

- Description updated

#6 - 09/04/2015 11:50 PM - Daniel Curtis
- Status changed from In Progress to Resolved

- % Done changed from 80 to 100

#7 - 09/11/2015 05:23 PM - Daniel Curtis

- Status changed from Resolved to Closed

#8 - 02/12/2016 11:59 AM - Daniel Curtis
- Description updated

#9 - 02/12/2016 10:38 PM - Daniel Curtis
- Description updated

#10 - 02/13/2016 08:01 PM - Daniel Curtis
- Description updated

#11 - 02/13/2016 10:03 PM - Daniel Curtis
- Description updated

#12 - 02/14/2016 11:45 AM - Daniel Curtis
- Description updated

#13 - 02/14/2016 08:38 PM - Daniel Curtis
- Description updated

#14 - 02/14/2016 10:40 PM - Daniel Curtis
- Description updated

#15 - 02/15/2016 05:11 PM - Daniel Curtis
- Description updated

#16 - 02/15/2016 05:35 PM - Daniel Curtis

- Description updated

#17 - 02/16/2016 06:56 AM - Daniel Curtis

- Description updated

#18 - 02/17/2016 07:42 AM - Daniel Curtis

- Description updated

#19 - 02/18/2016 10:38 PM - Daniel Curtis

- Description updated

#20 - 02/19/2016 08:29 PM - Daniel Curtis

- Description updated
#21 - 10/20/2016 06:33 PM - Daniel Curtis
- Description updated
- Target version changed from FreeBSD 9 to FreeBSD 10

#22 - 10/20/2016 09:12 PM - Daniel Curtis

- Description updated

#23 - 10/20/2016 10:38 PM - Daniel Curtis

- Description updated

#24 - 10/22/2016 06:06 PM - Daniel Curtis

- Description updated

#25 - 10/24/2016 03:38 PM - Daniel Curtis

- Description updated

#26 - 10/25/2016 04:07 PM - Daniel Curtis

- Description updated

#27 - 10/26/2016 05:49 PM - Daniel Curtis

- Description updated

#28 - 10/26/2016 09:53 PM - Daniel Curtis

- Description updated
